print:
	call print_without_line
	mov bx, newline
	call print_without_line
	ret

print_without_line:
	pusha
	mov ah, 0x0e
	jmp print_loop

print_loop:
	mov al, [bx]
	cmp al, 0
	je print_end
	int 0x10
	inc bx
	jmp print_loop

print_end:
	popa
	ret

hex:db "0123456789ABCDEF",0
newline:db 13,10,0
message_addr:dw 0
dbg_str_mid:db " 0x",0
error_code:db 0
err_msg:db 0,0

debug: ; also print byte in hexadecimal
	pusha
	mov bx, [message_addr]
	call print_without_line
	mov bx, dbg_str_mid
	call print_without_line
	
	mov dh, [error_code]
	mov dl, dh
	shr dh, 4
	and dl, 0FH
	
	mov bx, hex
	add bl, dh
	mov bx, [bx]
	mov [err_msg], bl
	mov bx, err_msg
	call print_without_line
	
	mov bx, hex
	add bl, dl
	mov bx, [bx]
	mov [err_msg], bl
	mov bx, err_msg
	call print
	
	popa
	ret